## libdrumstick 2.9.1

=== debian/changelog ===
libdrumstick (2.9.1-1) unstable; urgency=medium

  * New upstream version 2.9.1
  * Bump Standards-Version to 4.7.0
  * Change B-D pkg-config -> pkgconf

 -- Dennis Braun <snd@debian.org>  Fri, 13 Sep 2024 20:50:03 +0200

libdrumstick (2.9.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062273

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 18:53:30 +0000
