=== debian/changelog ===
libdrumstick (2.10.0-1) unstable; urgency=medium

  * New upstream version 2.10.0

 -- Dennis Braun <snd@debian.org>  Sun, 29 Dec 2024 17:48:28 +0100
